import requests
from bs4 import BeautifulSoup
import re
import tkinter as tk
from tkinter import ttk
import httplib2
from urllib.parse import urlencode


cip = '127.0.0.1'
ip_location = ''
try:
    res = requests.get('http://baidu.com')
    res.encoding = 'utf-8'
    soup = BeautifulSoup(res.text, features="html.parser")
except Exception as e:
    pass


def get_ip():
    global cip
    ip_html = requests.get("http://txt.go.sohu.com/ip/soip")
    # 返回公网ip的网站
    cur_public_ip = re.findall(r'\d+.\d+.\d+.\d+', ip_html.text)
    # 从响应中匹配公网ip
    cip = cur_public_ip[0]


def run(ip0=get_ip()):
    global soup
    headers = {
        'Host': 'iknowwhatyoudownload.com',
        'User-Agent': 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:99.0) Gecko/20100101 Firefox/99.0',
        'Accept': 'text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,*/*;q=0.8',
        'Accept-Language': 'zh-CN,zh;q=0.8,zh-TW;q=0.7,zh-HK;q=0.5,en-US;q=0.3,en;q=0.2',
        'Accept-Encoding': 'gzip, deflate, br',
        'DNT': '1',
        'Alt-Used': 'iknowwhatyoudownload.com',
        'Connection': 'keep-alive',
        'Referer': 'https://iknowwhatyoudownload.com/en/torrent'
                   '/694b74bc611bde381ed3e6cc81e045dca5892c9abf2958ab4b4fad30376251374db4f43523a95481292515d30cf669e0'
                   '/shijou_saikyou_no_daimaou_murabito_a_ni_tensei_suru_02_mp4',
        'Upgrade-Insecure-Requests': '1',
        'Sec-Fetch-Dest': 'document',
        'Sec-Fetch-Mode': 'navigate',
        'Sec-Fetch-Site': 'same-origin',
        'Sec-Fetch-User': '?1',
        'Pragma': 'no-cache',
        'Cache-Control': 'no-cache'
    }
    u = "https://iknowwhatyoudownload.com/en/peer/?ip=" + ip0
    res1 = requests.get(u, headers=headers)
    res1.encoding = 'utf-8'
    soup = BeautifulSoup(res1.text, features="html.parser")

def seen_time(soup0):
    # Seen Time
    flag = True
    date_item = []
    date_items = soup0.find_all("td", class_="date-column")
    for date in date_items:
        flag = not flag
        if flag:
            date_item.append(date.text.strip())
    return date_item


def class_name(soup0):
    # Class Name
    classname = []
    class_names = soup0.find_all("td", class_="category-column")
    for name in class_names:
        classname.append(name.text.strip())
    return classname


def title_name(soup0):
    # Title Name
    titlename = []
    title_names = soup0.find_all("td", class_="name-column")
    for title in title_names:
        titlename.append(title.text.strip())
    return titlename


def win_info():
    txt1 = 'x:%d,y:%d,w:%d,h:%d' % (window.winfo_x(), window.winfo_y(), window.winfo_width(), window.winfo_height())
    label1.configure(text=txt1, font=('黑体', '8'))
    label1.place(x=0, y=window.winfo_height() - 15)
    txt2 = '设备公网IP地址: %s' % cip
    label2.configure(text=txt2, font=('黑体', '8'))
    label2.place(x=window.winfo_width() - 210, y=window.winfo_height() - 15)
    l1.configure(text='当前IP归属地:%s,%s,%s,%s' % (ip_location[0], ip_location[1], ip_location[2], ip_location[3]))
    l1.place(x=window.winfo_width() - 320, y=10)
    l2.configure(text='运营商:%s  邮编:%s  区号:%s' % (ip_location[4], ip_location[5], ip_location[6]))
    l2.place(x=window.winfo_width() - 320, y=30)
    fresh_button.place(x=window.winfo_width() - 20, y=window.winfo_height() - 13, width=15, height=10)
    window.after(2, win_info)


def location():
    # row 1
    l0.place(x=40, y=20, width=50, height=30)
    submit_ip.place(x=100, y=20, width=180, height=30)
    search_button.place(x=300, y=20, width=50, height=30)
    # row 2
    sep0.place(x=0, y=60, width=window.winfo_width(), height=1)
    tree.place(x=0, y=65, width=window.winfo_width(), height=window.winfo_height() - 65 - 15)
    window.after(10, location)

def delete_tree():
    x = tree.get_children()
    for item in x:
        tree.delete(item)

def search():
    ip = submit_ip.get()
    run(str(ip))
    delete_tree()
    get_location_by_ip(ip)
    t = seen_time(soup)
    c = class_name(soup)
    n = title_name(soup)
    for i in range(len(t)):
        tree.insert('', 'end', values=(t[i], c[i], n[i]))

def get_location_by_ip(ip):
    global ip_location
    params = urlencode({'ip': ip, 'datatype': 'jsonp', 'callback': 'find'})
    url = 'https://api.ip138.com/ip/?' + params
    headers = {"token": "25ee05c51afd4619d57591245830d288"}  # token只有1000次查询余额
    http = httplib2.Http()
    response, content = http.request(url, 'GET', headers=headers)
    findall = re.findall(r'[\[](.*)[\]]', str(content.decode("utf-8")))
    ip_location = findall[0].split(',')
    print(ip_location)


if __name__ == '__main__':
    get_ip()
    window = tk.Tk()
    window.title('公网IP下载记录查询——By SmellyPig™ QQ:1634312201')
    window.geometry('700x300+413+270')
    # window.minsize(400, 300)
    window.resizable(False, True)
    get_location_by_ip(cip)
    # info
    label1 = tk.Label(window)
    label2 = tk.Label(window)
    fresh_button = tk.Button(window, command=get_ip, text='R', font=('黑体', 8))  # IP刷新按钮
    # row 1
    l0 = tk.Label(window, text='Ip:', font=('黑体', 12))
    l1 = tk.Label(window, font=('黑体', 10))
    l2 = tk.Label(window, font=('黑体', 10))
    submit_ip = tk.Entry(window, font=('黑体', 12))
    submit_ip.insert(0, cip)
    search_button = tk.Button(window, text='查询', command=search)
    # row 2
    sep0 = ttk.Separator(window, orient='horizontal')  # line
    tree = ttk.Treeview(window, columns=['1', '2', '3'], show='headings')
    tree.column('1', width=160, anchor='center')
    tree.column('2', width=50, anchor='center')
    tree.column('3', width=490, anchor='center')
    tree.heading('1', text='下载时间')
    tree.heading('2', text='类名')
    tree.heading('3', text='标题')
    win_info()
    location()
    window.mainloop()
